from typing import Any, Dict, List, Type, TypeVar

import attr

T = TypeVar("T", bound="OneTimeTokenIn")


@attr.s(auto_attribs=True)
class OneTimeTokenIn:
    """
    Attributes:
        one_time_token (str):
    """

    one_time_token: str
    additional_properties: Dict[str, Any] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        one_time_token = self.one_time_token

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "oneTimeToken": one_time_token,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        dict_copy = src_dict.copy()
        one_time_token = dict_copy.pop("oneTimeToken")

        one_time_token_in = cls(
            one_time_token=one_time_token,
        )

        one_time_token_in.additional_properties = dict_copy
        return one_time_token_in

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
